"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _parseUserArgs = _interopRequireDefault(require("./helpers/parseUserArgs"));
var _readConfigFile = require("./readConfigFile");
var _tagProcessor = require("./tag-processor");
var _testRunner = require("./test-runner");
var _logger = require("../../utils/logger");
// @cucumber/gherkins need to be includ in package.json

// const getFeatureFiles = (dir) => {
//     let featureFiles = [];
//     const files = fs.readdirSync(dir, { withFileTypes: true });
//     files.forEach(file => {
//       const fullPath = path.join(dir, file.name);
//       if (file.isDirectory()) {
//         featureFiles = featureFiles.concat(getFeatureFiles(fullPath));
//       } else if (file.isFile() && fullPath.endsWith('.feature')) {
//         featureFiles.push(fullPath);
//       }
//     });
//     return featureFiles;
//   };

//const validateFeatureFiles = () => {
// const featuresDir = path.join(process.cwd(), 'uat/modules');
// const parser = new Parser();
// const featureFiles = getFeatureFiles(featuresDir);
// featureFiles.forEach( filePath => {
//         const featureFileContent = fs.readFileSync(filePath, 'utf-8');
//         try {
//             parser.parse(featureFileContent);
//             console.log(`${filePath}: Feature file is valid!`);
//         } catch (error) {
//             console.error(`${filePath}: Feature file is invalid - ${error.message}`);
//         }
// })
//}

const validateFeatureFiles = () => {
  const userArgsObject = (0, _parseUserArgs.default)();
  const uatConfig = (0, _readConfigFile.generateConfigFromFile)();
  const {
    editionOrder
  } = uatConfig;
  const configPath = (0, _readConfigFile.isUserConfigFileAvailable)() ? require.resolve('./setup/config-creator.js') : require.resolve('../../../playwright.config.js');
  const tagArgs = (0, _tagProcessor.tagProcessor)(userArgsObject, editionOrder);
  (0, _testRunner.runPreprocessing)(tagArgs, configPath).then(() => {
    _logger.Logger.log(_logger.Logger.SUCCESS_TYPE, 'Feature files validated successfully.');
  }).catch(error => {
    _logger.Logger.log(_logger.Logger.FAILURE_TYPE, `Error while validating the feature files - ${error}`);
  });
};
var _default = exports.default = validateFeatureFiles;